/* Library.c generated by valac 0.32.1, the Vala compiler
 * generated from Library.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define NOISE_TYPE_LIBRARY (noise_library_get_type ())
#define NOISE_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY, NoiseLibrary))
#define NOISE_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY, NoiseLibraryClass))
#define NOISE_IS_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY))
#define NOISE_IS_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY))
#define NOISE_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY, NoiseLibraryClass))

typedef struct _NoiseLibrary NoiseLibrary;
typedef struct _NoiseLibraryClass NoiseLibraryClass;
typedef struct _NoiseLibraryPrivate NoiseLibraryPrivate;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;

#define NOISE_TYPE_PLAYLIST (noise_playlist_get_type ())
#define NOISE_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylist))
#define NOISE_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))
#define NOISE_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYLIST))
#define NOISE_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYLIST))
#define NOISE_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))

typedef struct _NoisePlaylist NoisePlaylist;
typedef struct _NoisePlaylistClass NoisePlaylistClass;

#define NOISE_TYPE_STATIC_PLAYLIST (noise_static_playlist_get_type ())
#define NOISE_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist))
#define NOISE_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistClass))
#define NOISE_IS_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STATIC_PLAYLIST))
#define NOISE_IS_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STATIC_PLAYLIST))
#define NOISE_STATIC_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylistClass))

typedef struct _NoiseStaticPlaylist NoiseStaticPlaylist;
typedef struct _NoiseStaticPlaylistClass NoiseStaticPlaylistClass;

#define NOISE_TYPE_SMART_PLAYLIST (noise_smart_playlist_get_type ())
#define NOISE_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylist))
#define NOISE_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylistClass))
#define NOISE_IS_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SMART_PLAYLIST))
#define NOISE_IS_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SMART_PLAYLIST))
#define NOISE_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SMART_PLAYLIST, NoiseSmartPlaylistClass))

typedef struct _NoiseSmartPlaylist NoiseSmartPlaylist;
typedef struct _NoiseSmartPlaylistClass NoiseSmartPlaylistClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoiseLibrary {
	GObject parent_instance;
	NoiseLibraryPrivate * priv;
};

struct _NoiseLibraryClass {
	GObjectClass parent_class;
	void (*initialize_library) (NoiseLibrary* self);
	void (*add_files_to_library) (NoiseLibrary* self, GeeCollection* files);
	GeeCollection* (*get_medias) (NoiseLibrary* self);
	GeeCollection* (*get_playlists) (NoiseLibrary* self);
	GeeCollection* (*get_smart_playlists) (NoiseLibrary* self);
	void (*search_medias) (NoiseLibrary* self, const gchar* search);
	GeeCollection* (*get_search_result) (NoiseLibrary* self);
	void (*add_media) (NoiseLibrary* self, NoiseMedia* s);
	void (*add_medias) (NoiseLibrary* self, GeeCollection* new_media);
	NoiseMedia* (*find_media) (NoiseLibrary* self, NoiseMedia* to_find);
	NoiseMedia* (*media_from_file) (NoiseLibrary* self, GFile* file);
	NoiseMedia* (*media_from_uri) (NoiseLibrary* self, const gchar* uri);
	NoiseMedia* (*media_from_id) (NoiseLibrary* self, gint64 id);
	GeeCollection* (*medias_from_uris) (NoiseLibrary* self, GeeCollection* uris);
	GeeCollection* (*medias_from_ids) (NoiseLibrary* self, GeeCollection* ids);
	void (*update_media) (NoiseLibrary* self, NoiseMedia* s, gboolean updateMeta, gboolean record_time);
	void (*update_medias) (NoiseLibrary* self, GeeCollection* updates, gboolean updateMeta, gboolean record_time);
	void (*remove_media) (NoiseLibrary* self, NoiseMedia* s, gboolean trash);
	void (*remove_medias) (NoiseLibrary* self, GeeCollection* toRemove, gboolean trash);
	gboolean (*support_smart_playlists) (NoiseLibrary* self);
	void (*add_smart_playlist) (NoiseLibrary* self, NoiseSmartPlaylist* p);
	void (*remove_smart_playlist) (NoiseLibrary* self, gint64 id);
	NoiseSmartPlaylist* (*smart_playlist_from_id) (NoiseLibrary* self, gint64 id);
	NoiseSmartPlaylist* (*smart_playlist_from_name) (NoiseLibrary* self, const gchar* name);
	gboolean (*support_playlists) (NoiseLibrary* self);
	void (*add_playlist) (NoiseLibrary* self, NoiseStaticPlaylist* p);
	void (*remove_playlist) (NoiseLibrary* self, gint64 id);
	NoiseStaticPlaylist* (*playlist_from_id) (NoiseLibrary* self, gint64 id);
	NoiseStaticPlaylist* (*playlist_from_name) (NoiseLibrary* self, const gchar* name);
	gboolean (*start_file_operations) (NoiseLibrary* self, const gchar* message);
	gboolean (*doing_file_operations) (NoiseLibrary* self);
	void (*finish_file_operations) (NoiseLibrary* self);
};


static gpointer noise_library_parent_class = NULL;

GType noise_library_get_type (void) G_GNUC_CONST;
GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_playlist_get_type (void) G_GNUC_CONST;
GType noise_static_playlist_get_type (void) G_GNUC_CONST;
GType noise_smart_playlist_get_type (void) G_GNUC_CONST;
enum  {
	NOISE_LIBRARY_DUMMY_PROPERTY
};
void noise_library_initialize_library (NoiseLibrary* self);
static void noise_library_real_initialize_library (NoiseLibrary* self);
void noise_library_add_files_to_library (NoiseLibrary* self, GeeCollection* files);
static void noise_library_real_add_files_to_library (NoiseLibrary* self, GeeCollection* files);
GeeCollection* noise_library_get_medias (NoiseLibrary* self);
static GeeCollection* noise_library_real_get_medias (NoiseLibrary* self);
GeeCollection* noise_library_get_playlists (NoiseLibrary* self);
static GeeCollection* noise_library_real_get_playlists (NoiseLibrary* self);
GeeCollection* noise_library_get_smart_playlists (NoiseLibrary* self);
static GeeCollection* noise_library_real_get_smart_playlists (NoiseLibrary* self);
void noise_library_search_medias (NoiseLibrary* self, const gchar* search);
static void noise_library_real_search_medias (NoiseLibrary* self, const gchar* search);
GeeCollection* noise_library_get_search_result (NoiseLibrary* self);
static GeeCollection* noise_library_real_get_search_result (NoiseLibrary* self);
void noise_library_add_media (NoiseLibrary* self, NoiseMedia* s);
static void noise_library_real_add_media (NoiseLibrary* self, NoiseMedia* s);
void noise_library_add_medias (NoiseLibrary* self, GeeCollection* new_media);
static void noise_library_real_add_medias (NoiseLibrary* self, GeeCollection* new_media);
NoiseMedia* noise_library_find_media (NoiseLibrary* self, NoiseMedia* to_find);
static NoiseMedia* noise_library_real_find_media (NoiseLibrary* self, NoiseMedia* to_find);
NoiseMedia* noise_library_media_from_file (NoiseLibrary* self, GFile* file);
static NoiseMedia* noise_library_real_media_from_file (NoiseLibrary* self, GFile* file);
NoiseMedia* noise_library_media_from_uri (NoiseLibrary* self, const gchar* uri);
static NoiseMedia* noise_library_real_media_from_uri (NoiseLibrary* self, const gchar* uri);
NoiseMedia* noise_library_media_from_id (NoiseLibrary* self, gint64 id);
static NoiseMedia* noise_library_real_media_from_id (NoiseLibrary* self, gint64 id);
GeeCollection* noise_library_medias_from_uris (NoiseLibrary* self, GeeCollection* uris);
static GeeCollection* noise_library_real_medias_from_uris (NoiseLibrary* self, GeeCollection* uris);
GeeCollection* noise_library_medias_from_ids (NoiseLibrary* self, GeeCollection* ids);
static GeeCollection* noise_library_real_medias_from_ids (NoiseLibrary* self, GeeCollection* ids);
void noise_library_update_media (NoiseLibrary* self, NoiseMedia* s, gboolean updateMeta, gboolean record_time);
static void noise_library_real_update_media (NoiseLibrary* self, NoiseMedia* s, gboolean updateMeta, gboolean record_time);
void noise_library_update_medias (NoiseLibrary* self, GeeCollection* updates, gboolean updateMeta, gboolean record_time);
static void noise_library_real_update_medias (NoiseLibrary* self, GeeCollection* updates, gboolean updateMeta, gboolean record_time);
void noise_library_remove_media (NoiseLibrary* self, NoiseMedia* s, gboolean trash);
static void noise_library_real_remove_media (NoiseLibrary* self, NoiseMedia* s, gboolean trash);
void noise_library_remove_medias (NoiseLibrary* self, GeeCollection* toRemove, gboolean trash);
static void noise_library_real_remove_medias (NoiseLibrary* self, GeeCollection* toRemove, gboolean trash);
gboolean noise_library_support_smart_playlists (NoiseLibrary* self);
static gboolean noise_library_real_support_smart_playlists (NoiseLibrary* self);
void noise_library_add_smart_playlist (NoiseLibrary* self, NoiseSmartPlaylist* p);
static void noise_library_real_add_smart_playlist (NoiseLibrary* self, NoiseSmartPlaylist* p);
void noise_library_remove_smart_playlist (NoiseLibrary* self, gint64 id);
static void noise_library_real_remove_smart_playlist (NoiseLibrary* self, gint64 id);
NoiseSmartPlaylist* noise_library_smart_playlist_from_id (NoiseLibrary* self, gint64 id);
static NoiseSmartPlaylist* noise_library_real_smart_playlist_from_id (NoiseLibrary* self, gint64 id);
NoiseSmartPlaylist* noise_library_smart_playlist_from_name (NoiseLibrary* self, const gchar* name);
static NoiseSmartPlaylist* noise_library_real_smart_playlist_from_name (NoiseLibrary* self, const gchar* name);
gboolean noise_library_support_playlists (NoiseLibrary* self);
static gboolean noise_library_real_support_playlists (NoiseLibrary* self);
void noise_library_add_playlist (NoiseLibrary* self, NoiseStaticPlaylist* p);
static void noise_library_real_add_playlist (NoiseLibrary* self, NoiseStaticPlaylist* p);
void noise_library_remove_playlist (NoiseLibrary* self, gint64 id);
static void noise_library_real_remove_playlist (NoiseLibrary* self, gint64 id);
NoiseStaticPlaylist* noise_library_playlist_from_id (NoiseLibrary* self, gint64 id);
static NoiseStaticPlaylist* noise_library_real_playlist_from_id (NoiseLibrary* self, gint64 id);
NoiseStaticPlaylist* noise_library_playlist_from_name (NoiseLibrary* self, const gchar* name);
static NoiseStaticPlaylist* noise_library_real_playlist_from_name (NoiseLibrary* self, const gchar* name);
gboolean noise_library_start_file_operations (NoiseLibrary* self, const gchar* message);
static gboolean noise_library_real_start_file_operations (NoiseLibrary* self, const gchar* message);
gboolean noise_library_doing_file_operations (NoiseLibrary* self);
static gboolean noise_library_real_doing_file_operations (NoiseLibrary* self);
void noise_library_finish_file_operations (NoiseLibrary* self);
static void noise_library_real_finish_file_operations (NoiseLibrary* self);
gint noise_library_playlist_count_without_read_only (NoiseLibrary* self);
gboolean noise_static_playlist_get_read_only (NoiseStaticPlaylist* self);
void noise_library_media_from_name (NoiseLibrary* self, GeeCollection* tests, GeeCollection* found, GeeCollection* not_found);
gint64 noise_media_get_rowid (NoiseMedia* self);
NoiseLibrary* noise_library_construct (GType object_type);


static void noise_library_real_initialize_library (NoiseLibrary* self) {
#line 52 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_initialize_library'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 52 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 221 "Library.c"
}


void noise_library_initialize_library (NoiseLibrary* self) {
#line 52 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 52 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->initialize_library (self);
#line 230 "Library.c"
}


static void noise_library_real_add_files_to_library (NoiseLibrary* self, GeeCollection* files) {
#line 53 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_add_files_to_library'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 53 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 239 "Library.c"
}


void noise_library_add_files_to_library (NoiseLibrary* self, GeeCollection* files) {
#line 53 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 53 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->add_files_to_library (self, files);
#line 248 "Library.c"
}


static GeeCollection* noise_library_real_get_medias (NoiseLibrary* self) {
#line 55 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_get_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 55 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 257 "Library.c"
}


GeeCollection* noise_library_get_medias (NoiseLibrary* self) {
#line 55 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->get_medias (self);
#line 266 "Library.c"
}


static GeeCollection* noise_library_real_get_playlists (NoiseLibrary* self) {
#line 56 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_get_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 56 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 275 "Library.c"
}


GeeCollection* noise_library_get_playlists (NoiseLibrary* self) {
#line 56 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->get_playlists (self);
#line 284 "Library.c"
}


static GeeCollection* noise_library_real_get_smart_playlists (NoiseLibrary* self) {
#line 57 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_get_smart_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 57 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 293 "Library.c"
}


GeeCollection* noise_library_get_smart_playlists (NoiseLibrary* self) {
#line 57 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->get_smart_playlists (self);
#line 302 "Library.c"
}


static void noise_library_real_search_medias (NoiseLibrary* self, const gchar* search) {
#line 59 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_search_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 59 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 311 "Library.c"
}


void noise_library_search_medias (NoiseLibrary* self, const gchar* search) {
#line 59 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 59 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->search_medias (self, search);
#line 320 "Library.c"
}


static GeeCollection* noise_library_real_get_search_result (NoiseLibrary* self) {
#line 60 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_get_search_result'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 60 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 329 "Library.c"
}


GeeCollection* noise_library_get_search_result (NoiseLibrary* self) {
#line 60 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->get_search_result (self);
#line 338 "Library.c"
}


static void noise_library_real_add_media (NoiseLibrary* self, NoiseMedia* s) {
#line 62 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_add_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 62 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 347 "Library.c"
}


void noise_library_add_media (NoiseLibrary* self, NoiseMedia* s) {
#line 62 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 62 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->add_media (self, s);
#line 356 "Library.c"
}


static void noise_library_real_add_medias (NoiseLibrary* self, GeeCollection* new_media) {
#line 63 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_add_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 63 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 365 "Library.c"
}


void noise_library_add_medias (NoiseLibrary* self, GeeCollection* new_media) {
#line 63 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 63 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->add_medias (self, new_media);
#line 374 "Library.c"
}


static NoiseMedia* noise_library_real_find_media (NoiseLibrary* self, NoiseMedia* to_find) {
#line 64 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_find_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 64 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 383 "Library.c"
}


NoiseMedia* noise_library_find_media (NoiseLibrary* self, NoiseMedia* to_find) {
#line 64 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->find_media (self, to_find);
#line 392 "Library.c"
}


static NoiseMedia* noise_library_real_media_from_file (NoiseLibrary* self, GFile* file) {
#line 65 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_media_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 65 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 401 "Library.c"
}


NoiseMedia* noise_library_media_from_file (NoiseLibrary* self, GFile* file) {
#line 65 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->media_from_file (self, file);
#line 410 "Library.c"
}


static NoiseMedia* noise_library_real_media_from_uri (NoiseLibrary* self, const gchar* uri) {
#line 66 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_media_from_uri'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 66 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 419 "Library.c"
}


NoiseMedia* noise_library_media_from_uri (NoiseLibrary* self, const gchar* uri) {
#line 66 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->media_from_uri (self, uri);
#line 428 "Library.c"
}


static NoiseMedia* noise_library_real_media_from_id (NoiseLibrary* self, gint64 id) {
#line 67 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_media_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 67 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 437 "Library.c"
}


NoiseMedia* noise_library_media_from_id (NoiseLibrary* self, gint64 id) {
#line 67 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->media_from_id (self, id);
#line 446 "Library.c"
}


static GeeCollection* noise_library_real_medias_from_uris (NoiseLibrary* self, GeeCollection* uris) {
#line 68 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_medias_from_uris'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 68 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 455 "Library.c"
}


GeeCollection* noise_library_medias_from_uris (NoiseLibrary* self, GeeCollection* uris) {
#line 68 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->medias_from_uris (self, uris);
#line 464 "Library.c"
}


static GeeCollection* noise_library_real_medias_from_ids (NoiseLibrary* self, GeeCollection* ids) {
#line 69 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_medias_from_ids'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 69 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 473 "Library.c"
}


GeeCollection* noise_library_medias_from_ids (NoiseLibrary* self, GeeCollection* ids) {
#line 69 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->medias_from_ids (self, ids);
#line 482 "Library.c"
}


static void noise_library_real_update_media (NoiseLibrary* self, NoiseMedia* s, gboolean updateMeta, gboolean record_time) {
#line 70 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_update_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 70 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 491 "Library.c"
}


void noise_library_update_media (NoiseLibrary* self, NoiseMedia* s, gboolean updateMeta, gboolean record_time) {
#line 70 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 70 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->update_media (self, s, updateMeta, record_time);
#line 500 "Library.c"
}


static void noise_library_real_update_medias (NoiseLibrary* self, GeeCollection* updates, gboolean updateMeta, gboolean record_time) {
#line 71 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_update_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 71 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 509 "Library.c"
}


void noise_library_update_medias (NoiseLibrary* self, GeeCollection* updates, gboolean updateMeta, gboolean record_time) {
#line 71 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 71 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->update_medias (self, updates, updateMeta, record_time);
#line 518 "Library.c"
}


static void noise_library_real_remove_media (NoiseLibrary* self, NoiseMedia* s, gboolean trash) {
#line 72 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_remove_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 72 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 527 "Library.c"
}


void noise_library_remove_media (NoiseLibrary* self, NoiseMedia* s, gboolean trash) {
#line 72 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 72 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->remove_media (self, s, trash);
#line 536 "Library.c"
}


static void noise_library_real_remove_medias (NoiseLibrary* self, GeeCollection* toRemove, gboolean trash) {
#line 73 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_remove_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 73 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 545 "Library.c"
}


void noise_library_remove_medias (NoiseLibrary* self, GeeCollection* toRemove, gboolean trash) {
#line 73 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 73 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->remove_medias (self, toRemove, trash);
#line 554 "Library.c"
}


static gboolean noise_library_real_support_smart_playlists (NoiseLibrary* self) {
#line 75 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_support_smart_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 75 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return FALSE;
#line 563 "Library.c"
}


gboolean noise_library_support_smart_playlists (NoiseLibrary* self) {
#line 75 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->support_smart_playlists (self);
#line 572 "Library.c"
}


static void noise_library_real_add_smart_playlist (NoiseLibrary* self, NoiseSmartPlaylist* p) {
#line 76 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_add_smart_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 76 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 581 "Library.c"
}


void noise_library_add_smart_playlist (NoiseLibrary* self, NoiseSmartPlaylist* p) {
#line 76 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 76 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->add_smart_playlist (self, p);
#line 590 "Library.c"
}


static void noise_library_real_remove_smart_playlist (NoiseLibrary* self, gint64 id) {
#line 77 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_remove_smart_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 77 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 599 "Library.c"
}


void noise_library_remove_smart_playlist (NoiseLibrary* self, gint64 id) {
#line 77 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 77 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->remove_smart_playlist (self, id);
#line 608 "Library.c"
}


static NoiseSmartPlaylist* noise_library_real_smart_playlist_from_id (NoiseLibrary* self, gint64 id) {
#line 78 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_smart_playlist_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 78 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 617 "Library.c"
}


NoiseSmartPlaylist* noise_library_smart_playlist_from_id (NoiseLibrary* self, gint64 id) {
#line 78 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->smart_playlist_from_id (self, id);
#line 626 "Library.c"
}


static NoiseSmartPlaylist* noise_library_real_smart_playlist_from_name (NoiseLibrary* self, const gchar* name) {
#line 79 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_smart_playlist_from_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 79 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 635 "Library.c"
}


NoiseSmartPlaylist* noise_library_smart_playlist_from_name (NoiseLibrary* self, const gchar* name) {
#line 79 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->smart_playlist_from_name (self, name);
#line 644 "Library.c"
}


static gboolean noise_library_real_support_playlists (NoiseLibrary* self) {
#line 81 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_support_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 81 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return FALSE;
#line 653 "Library.c"
}


gboolean noise_library_support_playlists (NoiseLibrary* self) {
#line 81 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->support_playlists (self);
#line 662 "Library.c"
}


static void noise_library_real_add_playlist (NoiseLibrary* self, NoiseStaticPlaylist* p) {
#line 82 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_add_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 82 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 671 "Library.c"
}


void noise_library_add_playlist (NoiseLibrary* self, NoiseStaticPlaylist* p) {
#line 82 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 82 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->add_playlist (self, p);
#line 680 "Library.c"
}


static void noise_library_real_remove_playlist (NoiseLibrary* self, gint64 id) {
#line 83 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_remove_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 83 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 689 "Library.c"
}


void noise_library_remove_playlist (NoiseLibrary* self, gint64 id) {
#line 83 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 83 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->remove_playlist (self, id);
#line 698 "Library.c"
}


static NoiseStaticPlaylist* noise_library_real_playlist_from_id (NoiseLibrary* self, gint64 id) {
#line 84 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_playlist_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 84 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 707 "Library.c"
}


NoiseStaticPlaylist* noise_library_playlist_from_id (NoiseLibrary* self, gint64 id) {
#line 84 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->playlist_from_id (self, id);
#line 716 "Library.c"
}


static NoiseStaticPlaylist* noise_library_real_playlist_from_name (NoiseLibrary* self, const gchar* name) {
#line 85 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_playlist_from_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 85 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NULL;
#line 725 "Library.c"
}


NoiseStaticPlaylist* noise_library_playlist_from_name (NoiseLibrary* self, const gchar* name) {
#line 85 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->playlist_from_name (self, name);
#line 734 "Library.c"
}


static gboolean noise_library_real_start_file_operations (NoiseLibrary* self, const gchar* message) {
#line 87 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_start_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 87 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return FALSE;
#line 743 "Library.c"
}


gboolean noise_library_start_file_operations (NoiseLibrary* self, const gchar* message) {
#line 87 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->start_file_operations (self, message);
#line 752 "Library.c"
}


static gboolean noise_library_real_doing_file_operations (NoiseLibrary* self) {
#line 88 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_doing_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 88 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return FALSE;
#line 761 "Library.c"
}


gboolean noise_library_doing_file_operations (NoiseLibrary* self) {
#line 88 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return NOISE_LIBRARY_GET_CLASS (self)->doing_file_operations (self);
#line 770 "Library.c"
}


static void noise_library_real_finish_file_operations (NoiseLibrary* self) {
#line 89 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_library_finish_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 89 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return;
#line 779 "Library.c"
}


void noise_library_finish_file_operations (NoiseLibrary* self) {
#line 89 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 89 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	NOISE_LIBRARY_GET_CLASS (self)->finish_file_operations (self);
#line 788 "Library.c"
}


gint noise_library_playlist_count_without_read_only (NoiseLibrary* self) {
	gint result = 0;
	gint i = 0;
#line 91 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	i = 0;
#line 799 "Library.c"
	{
		GeeIterator* _p_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_ = NULL;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_tmp0_ = noise_library_get_playlists (self);
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_tmp1_ = _tmp0_;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_tmp3_ = _tmp2_;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_g_object_unref0 (_tmp1_);
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_p_it = _tmp3_;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		while (TRUE) {
#line 820 "Library.c"
			GeeIterator* _tmp4_ = NULL;
			gboolean _tmp5_ = FALSE;
			NoiseStaticPlaylist* p = NULL;
			GeeIterator* _tmp6_ = NULL;
			gpointer _tmp7_ = NULL;
			NoiseStaticPlaylist* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp4_ = _p_it;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp5_ = gee_iterator_next (_tmp4_);
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			if (!_tmp5_) {
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				break;
#line 837 "Library.c"
			}
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp6_ = _p_it;
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			p = (NoiseStaticPlaylist*) _tmp7_;
#line 94 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp8_ = p;
#line 94 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp9_ = noise_static_playlist_get_read_only (_tmp8_);
#line 94 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp10_ = _tmp9_;
#line 94 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			if (_tmp10_ == FALSE) {
#line 853 "Library.c"
				gint _tmp11_ = 0;
#line 95 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp11_ = i;
#line 95 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				i = _tmp11_ + 1;
#line 859 "Library.c"
			}
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_g_object_unref0 (p);
#line 863 "Library.c"
		}
#line 93 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_g_object_unref0 (_p_it);
#line 867 "Library.c"
	}
#line 97 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	result = i;
#line 97 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return result;
#line 873 "Library.c"
}


void noise_library_media_from_name (NoiseLibrary* self, GeeCollection* tests, GeeCollection* found, GeeCollection* not_found) {
#line 100 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (self != NULL);
#line 100 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (tests != NULL);
#line 100 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (found != NULL);
#line 100 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_return_if_fail (not_found != NULL);
#line 886 "Library.c"
	{
		GeeIterator* _test_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_tmp0_ = tests;
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_test_it = _tmp1_;
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		while (TRUE) {
#line 899 "Library.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			NoiseMedia* test = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			NoiseMedia* media_found = NULL;
			NoiseMedia* _tmp6_ = NULL;
			NoiseMedia* _tmp7_ = NULL;
			NoiseMedia* _tmp8_ = NULL;
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp2_ = _test_it;
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			if (!_tmp3_) {
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				break;
#line 917 "Library.c"
			}
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp4_ = _test_it;
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			test = (NoiseMedia*) _tmp5_;
#line 102 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp6_ = test;
#line 102 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp7_ = noise_library_find_media (self, _tmp6_);
#line 102 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			media_found = _tmp7_;
#line 103 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_tmp8_ = media_found;
#line 103 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			if (_tmp8_ != NULL) {
#line 935 "Library.c"
				GeeCollection* _tmp9_ = NULL;
				NoiseMedia* _tmp10_ = NULL;
				gint64 _tmp11_ = 0LL;
				gint64 _tmp12_ = 0LL;
#line 104 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp9_ = found;
#line 104 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp10_ = media_found;
#line 104 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp11_ = noise_media_get_rowid (_tmp10_);
#line 104 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp12_ = _tmp11_;
#line 104 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				gee_collection_add (_tmp9_, &_tmp12_);
#line 950 "Library.c"
			} else {
				GeeCollection* _tmp13_ = NULL;
				NoiseMedia* _tmp14_ = NULL;
#line 106 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp13_ = not_found;
#line 106 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				_tmp14_ = test;
#line 106 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
				gee_collection_add (_tmp13_, _tmp14_);
#line 960 "Library.c"
			}
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_g_object_unref0 (media_found);
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
			_g_object_unref0 (test);
#line 966 "Library.c"
		}
#line 101 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
		_g_object_unref0 (_test_it);
#line 970 "Library.c"
	}
}


NoiseLibrary* noise_library_construct (GType object_type) {
	NoiseLibrary * self = NULL;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	self = (NoiseLibrary*) g_object_new (object_type, NULL);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	return self;
#line 981 "Library.c"
}


static void noise_library_class_init (NoiseLibraryClass * klass) {
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	noise_library_parent_class = g_type_class_peek_parent (klass);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->initialize_library = noise_library_real_initialize_library;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->add_files_to_library = noise_library_real_add_files_to_library;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->get_medias = noise_library_real_get_medias;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->get_playlists = noise_library_real_get_playlists;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->get_smart_playlists = noise_library_real_get_smart_playlists;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->search_medias = noise_library_real_search_medias;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->get_search_result = noise_library_real_get_search_result;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->add_media = noise_library_real_add_media;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->add_medias = noise_library_real_add_medias;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->find_media = noise_library_real_find_media;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->media_from_file = noise_library_real_media_from_file;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->media_from_uri = noise_library_real_media_from_uri;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->media_from_id = noise_library_real_media_from_id;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->medias_from_uris = noise_library_real_medias_from_uris;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->medias_from_ids = noise_library_real_medias_from_ids;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->update_media = noise_library_real_update_media;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->update_medias = noise_library_real_update_medias;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->remove_media = noise_library_real_remove_media;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->remove_medias = noise_library_real_remove_medias;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->support_smart_playlists = noise_library_real_support_smart_playlists;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->add_smart_playlist = noise_library_real_add_smart_playlist;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->remove_smart_playlist = noise_library_real_remove_smart_playlist;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->smart_playlist_from_id = noise_library_real_smart_playlist_from_id;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->smart_playlist_from_name = noise_library_real_smart_playlist_from_name;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->support_playlists = noise_library_real_support_playlists;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->add_playlist = noise_library_real_add_playlist;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->remove_playlist = noise_library_real_remove_playlist;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->playlist_from_id = noise_library_real_playlist_from_id;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->playlist_from_name = noise_library_real_playlist_from_name;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->start_file_operations = noise_library_real_start_file_operations;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->doing_file_operations = noise_library_real_doing_file_operations;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	((NoiseLibraryClass *) klass)->finish_file_operations = noise_library_real_finish_file_operations;
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("file_operations_started", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("file_operations_done", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("media_added", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("media_updated", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("media_removed", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("media_imported", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("search_finished", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("playlist_added", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_STATIC_PLAYLIST);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("playlist_name_updated", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_STATIC_PLAYLIST);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("playlist_removed", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_STATIC_PLAYLIST);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("smartplaylist_added", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_SMART_PLAYLIST);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("smartplaylist_name_updated", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_SMART_PLAYLIST);
#line 29 "/home/abuild/rpmbuild/BUILD/noise-0.4.0.3/core/Library.vala"
	g_signal_new ("smartplaylist_removed", NOISE_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_SMART_PLAYLIST);
#line 1078 "Library.c"
}


static void noise_library_instance_init (NoiseLibrary * self) {
}


GType noise_library_get_type (void) {
	static volatile gsize noise_library_type_id__volatile = 0;
	if (g_once_init_enter (&noise_library_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLibrary), 0, (GInstanceInitFunc) noise_library_instance_init, NULL };
		GType noise_library_type_id;
		noise_library_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseLibrary", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&noise_library_type_id__volatile, noise_library_type_id);
	}
	return noise_library_type_id__volatile;
}



